# PhasicFlow: InsertionRegion< ShapeType > Class Template Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

InsertionRegion< ShapeType > Class Template Reference

This manages insertion of particles from a region based on the ShapeType. More...

Inheritance diagram for InsertionRegion< ShapeType >:
[legend]
Collaboration diagram for InsertionRegion< ShapeType >:
[legend]

## Public Member Functions

| TypeInfoTemplateNV11 ("insertionRegion", ShapeType)
| Type info. More...
| InsertionRegion (const word &name, const insertion &instn, const ShapeType &shapes)
| Construct from dictionary. More...
| ~InsertionRegion ()=default
bool | insertParticles (uint32 iter, real t, real dt, wordVector &names, realx3Vector &pos, bool &insertionOccured)
| Insert particles at current time t Check if currentTime is the right moment for particle insertion. More...
Public Member Functions inherited from insertionRegion
| TypeInfoNV ("insertionRegion")
| Type info. More...
| insertionRegion (const word &name, const insertion &instn)
| Construct from a dictionary. More...
| ~insertionRegion ()=default
| Destructor. More...
const auto & | name () const
| Const ref to name of the region. More...
const auto & | type () const
| return type of insertion region More...
const auto & | dict () const
const auto & | Insertion () const
const pointStructure & | pStruct () const
bool | insertionTime (uint32 iter, real t, real dt) const
uint32 | numberToBeInserted (uint32 iter, real t, real dt)
uint32 | addToNumInserted (uint32 newInserted)
uint32 | totalInserted () const
auto & | mixture ()
auto & | pRegion ()
const auto & | setFieldList () const
bool | write (dictionary &dict) const
| read from dictionary More...

## Static Private Member Functions

static bool | checkForContact (const realx3Vector &pos, const realVector &diams, const realx3 &p, const real &d)

## Private Attributes

const ShapeType & | shapes_
| Ref to Shapes. More...

## Detailed Description

### template<typename ShapeType>
class pFlow::InsertionRegion< ShapeType >

This manages insertion of particles from a region based on the ShapeType.

Definition at line 42 of file InsertionRegion.hpp.

## Constructor & Destructor Documentation

## InsertionRegion()

InsertionRegion | ( | const word & | name,
|  | const insertion & | instn,
|  | const ShapeType & | shapes
| ) |  |

Construct from dictionary.

Definition at line 41 of file InsertionRegion.cpp.

## ~InsertionRegion()

~InsertionRegion | ( |  | ) |

default

## Member Function Documentation

## checkForContact()

bool checkForContact | ( | const realx3Vector & | pos,
|  | const realVector & | diams,
|  | const realx3 & | p,
|  | const real & | d
| ) |  |

staticprivate

Definition at line 23 of file InsertionRegion.cpp.

References ForAll, and length().

Here is the call graph for this function:

## TypeInfoTemplateNV11()

TypeInfoTemplateNV11 | ( | "insertionRegion" | ,
|  | ShapeType |
| ) |  |

Type info.

## insertParticles()

bool insertParticles | ( | uint32 | iter,
|  | real | t,
|  | real | dt,
|  | wordVector & | names,
|  | realx3Vector & | pos,
|  | bool & | insertionOccured
| ) |  |

Insert particles at current time t Check if currentTime is the right moment for particle insertion.

Fill the vectors name, pos and signal if particle insertion occured or not.

reserve enough space

Definition at line 54 of file InsertionRegion.cpp.

References Vector< T, Allocator >::capacity(), END_WARNING, pFlow::algorithms::KOKKOS::max(), pStruct, Vector< T, Allocator >::reserve(), and WARNING.

Here is the call graph for this function:

## Member Data Documentation

## shapes_

const ShapeType& shapes_

private

Ref to Shapes.

Definition at line 48 of file InsertionRegion.hpp.

The documentation for this class was generated from the following files:

- src/Particles/Insertion/InsertionRegion/InsertionRegion.hpp
- src/Particles/Insertion/InsertionRegion/InsertionRegion.cpp